(function (window, $){
	"use strict"	
	var HAPAdManager = function(settings, parent, cmd, vol, audioUp2Js, progressLevel, mediaTimeAd, ss){
			
		var self = this,
		isIOS = navigator.userAgent.match(/(iPad|iPhone|iPod)/g),
		pauseAudioDuringAds = settings.pauseAudioDuringAds,
		adAudio,
		adPreOn,
		adMidAudio,
	    adMidTimeoutID,
	    adMidOn,
	    iosAdMidFixStart, 
	    iosAdMidFixPlay, 
	    iosAdMidFixEnd,
	    adEndOn,
	    adCounter = 0,
	    currMediaData = cmd,
	    volume = vol,
	    seekBarSize = ss



	    $(parent).on('volumeChange', function(e, data){
	        //called on volume change, returns (instance, instanceName, volume)
	        volume = data.volume;
	        if(adMidAudio)adMidAudio.volume = volume;
    	});


	    //ad pre

		this.initAdPre = function(){

			adPreOn = true;

			audioUp2Js.addEventListener("loadedmetadata", adPrePlay, false);
			audioUp2Js.addEventListener("ended", adPreEnded, false);
			audioUp2Js.src = currMediaData.adPre[adCounter];

		}
		
		function adPrePlay() {
			audioUp2Js.removeEventListener("loadedmetadata", adPrePlay, false);

			$(self).trigger('HAPAdManager.ADPRE_PLAY');

			adAudio = audioUp2Js;
			adAudio.addEventListener("timeupdate", adTimeUpdate, false);
			adTimeUpdate();

		}

	    function adPreEnded() {

	    	//we can have multiple ads
	    	adCounter++;
			if(adCounter < currMediaData.adPre.length){

				adAudio.src = currMediaData.adPre[adCounter];
				var promise = adAudio.play();
				if (promise !== undefined) {
					promise.then(function(){
				    }).catch(function(error){
					});
				}

			}else{

		    	adAudio.removeEventListener("timeupdate", adTimeUpdate, false);
		    	audioUp2Js.removeEventListener("ended", adPreEnded, false);
		    	adPreOn = false;
		    	adCounter = 0;

		    	$(self).trigger('HAPAdManager.ADPRE_ENDED');

			}
	    }

	    //ad mid

		function adMidPlay() {
			if(isIOS && !iosAdMidFixPlay){
				iosAdMidFixPlay = true;
				return;
			}

			if(pauseAudioDuringAds){

				$(self).trigger('HAPAdManager.ADMID_PLAY');

				adAudio = adMidAudio;
				adAudio.addEventListener("timeupdate", adTimeUpdate, false);

			}

	        adMidOn = true;
			adMidAudio.volume = volume;
	        $(parent).trigger("adMidPlay", {instance:parent, instanceName:settings.instanceName, data:currMediaData.adMid});
		}
	      
	    function adMidEnded() {
	    	if(isIOS && !iosAdMidFixEnd){
	    		iosAdMidFixEnd = true;
	    		return;
	    	}

	    	if(pauseAudioDuringAds){

		    	adAudio.removeEventListener("timeupdate", adTimeUpdate, false);

		    	$(self).trigger('HAPAdManager.ADMID_ENDED');

			}

	    	adMidOn = false;
	    	$(parent).trigger("adMidEnded", {instance:parent, instanceName:settings.instanceName, data:currMediaData.adMid});
	        startAdMidTimer();
	    }

	    function startAdMidTimer(){
	    	if(adMidTimeoutID)clearTimeout(adMidTimeoutID);
	    	var interval = currMediaData.adMidInterval || 10000; 
			adMidTimeoutID = setTimeout(function(){
				adMidTimeoutID = null;
				if(parent.getMediaPlaying()){
					adCounter++;
					if(adCounter > currMediaData.adMid.length-1)adCounter = 0;
					adMidAudio.src = currMediaData.adMid[adCounter];
					adMidAudio.play();
				}
	        }, parseInt(interval,10) + settings.dataInterval);
		}

		this.forceAdMidAudio = function(){
			iosAdMidFixStart = true;
			$(self).trigger('HAPAdManager.IOS_ADMID_FIX_START', true);
			if(!adMidAudio){
				adMidAudio = document.createElement("audio");
				adMidAudio.addEventListener("play", adMidPlay, false);
		        adMidAudio.addEventListener("ended", adMidEnded, false);
			}
			adMidAudio.src = settings.sourcePath + 'data/silence.mp3';
			adMidAudio.play();
		}

		this.adMidStartHandler = function(){

			if(!adMidAudio){
				adMidAudio = document.createElement("audio");
				adMidAudio.addEventListener("play", adMidPlay, false);
		        adMidAudio.addEventListener("ended", adMidEnded, false);
			}
			if(isIOS){
				if(iosAdMidFixEnd){
					startAdMidTimer();
				}
			}else{
				startAdMidTimer();
			}
		}

		this.adMidPlayHandler = function(){

			//if we paused audio and ad timer fired later while audio paused, we want to resume ad timer now
			if(!adMidTimeoutID){
				//console.log('audio resumed, but no ad timeout')
				if(isIOS){
					if(iosAdMidFixEnd){
						startAdMidTimer();
					}
				}else{
					startAdMidTimer();
				}
			}
		}

		this.clearAdMidTimeout = function(){
			if(adMidTimeoutID){
				clearTimeout(adMidTimeoutID);
				adMidTimeoutID = null;
			}
		}

		this.toggleAdMidAudio = function(){

			if(adMidAudio && pauseAudioDuringAds){
			    if(adMidAudio.paused) {
				    var promise = adMidAudio.play();
					if (promise !== undefined) {
						promise.then(function(){
					    }).catch(function(error){
					    });
					}
			    }else{
				    adMidAudio.pause();
			    }
			}
		}

		//ad end

		function adEndPlay() {
			audioUp2Js.removeEventListener("loadedmetadata", adEndPlay, false);

			$(self).trigger('HAPAdManager.ADEND_PLAY');

			adAudio = audioUp2Js;
			adAudio.addEventListener("timeupdate", adTimeUpdate, false);
		}

		function adEndEnded() {

			//we can have multiple ads
	    	adCounter++;
			if(adCounter < currMediaData.adEnd.length){

				adAudio.src = currMediaData.adEnd[adCounter];
				var promise = adAudio.play();
				if (promise !== undefined) {
					promise.then(function(){
				    }).catch(function(error){
					});
				}

			}else{

		    	adAudio.removeEventListener("timeupdate", adTimeUpdate, false);
		    	adAudio.removeEventListener("ended", adEndEnded, false);
		    	adEndOn = false;

		    	$(self).trigger('HAPAdManager.ADEND_ENDED');

		    }
	    }

	    this.setAdEnd = function(){

	    	adEndOn = true;
			adCounter = 0;

			audioUp2Js.addEventListener("loadedmetadata", adEndPlay, false);
			audioUp2Js.addEventListener("ended", adEndEnded, false);
			audioUp2Js.src = currMediaData.adEnd[adCounter];
		
			var promise = audioUp2Js.play();
			if (promise !== undefined) {
				promise.then(function(){
			    }).catch(function(error){
				});
			}
	    }

	    //ad time update

	    function adTimeUpdate(){
			if(adPreOn || adEndOn)var t = audioUp2Js.currentTime, d = audioUp2Js.duration;
			else if(adMidOn)var t = adMidAudio.currentTime, d = adMidAudio.duration;

			if(HAPUtils.isNumber(t) && HAPUtils.isNumber(d)){
				progressLevel.width((t / d) * seekBarSize);

				var adt = parseInt(d-t,10);
				mediaTimeAd.find('span').html(HAPUtils.formatTime(adt));
			}
		}

		this.isAdOn = function(){
			return (adPreOn || adMidOn || adEndOn);
		}

		this.isAdPreOn = function(){
			return adPreOn;
		}

		this.isAdMidOn = function(){
			return adMidOn;
		}

		this.isAdEndOn = function(){
			return adEndOn;
		}

		this.setAdData = function(cmd){
			currMediaData = cmd;
			adCounter = 0;
		}

		this.setSeekBarSize = function(v){
			seekBarSize = v;
		}

		this.cleanAds = function(){
			if(adAudio)adAudio.removeEventListener("timeupdate", adTimeUpdate, false);

			if(adPreOn){
				audioUp2Js.removeEventListener("loadedmetadata", adPrePlay, false);
				audioUp2Js.removeEventListener("ended", adPreEnded, false);
				adPreOn = false;
			}

			if(adMidTimeoutID){
				clearTimeout(adMidTimeoutID);
				adMidTimeoutID = null;
			}
			if(adMidOn){
				if(adMidAudio){
					adMidAudio.pause();
					adMidAudio.src = '';
				}
				adMidOn = false;
			}

			if(adEndOn){
				audioUp2Js.removeEventListener("loadedmetadata", adEndPlay, false);
				audioUp2Js.removeEventListener("ended", adEndEnded, false);
	    		adEndOn = false;
			}

		}


	};	

	window.HAPAdManager = HAPAdManager;

}(window,jQuery));
