(function (window, $){
	"use strict"	
	var HAPRadioData = function (settings, playerThumb){
			
		var self = this,
		isMobile = HAPUtils.isMobile(),
		mediaData,
		radioData,
		radioDataProcessed,
		lastPlayedSong,
		radioDataInited,
		radioCanceled,
		icecastStatusArr = ['/status-json.xsl', '/status.xsl'],
		activeIcecastStatus = 0,
		cors = settings.cors.split(',').map(function(item) {
		    return item.trim();
		}),
		activeCors = 0,
		lastPlayedIntervalID,
		lastPlayedInterval = settings.lastPlayedInterval,
		defaultSongArtist = settings.defaultSongArtist,
        defaultSongTitle = settings.defaultSongTitle

        if(playerThumb.length == 0)settings.getRadioArtwork = false;



		this.getData = function(data){

			if(data)mediaData = data;

			radioCanceled = false;

			if(mediaData.type == 'shoutcast')getShoutcastData();
			else if(mediaData.type == 'icecast')getIcecastData();
			else if(mediaData.type == 'radiojar')getRadiojarData();
			else console.log("HAPRadioData unknown radio data!")

		}
		
		function getShoutcastData(){

	    	var ip = mediaData.path;
	    	if(ip.substring(ip.length-1) == ";"){
	    		ip = ip.substring(0, ip.length-1);
	    	}
	    	if(ip.substring(ip.length-1) == "/"){
	    		ip = ip.substring(0, ip.length-1);
	    	}

	    	if(window.radioDataXHR)window.radioDataXHR.abort(); 

	        var xhr = new XMLHttpRequest;
	        xhr.onerror = function (e) {
	            //console.error(xhr.statusText);
	        };
	        xhr.onreadystatechange = function () {

	            if (this.readyState === 4){
	            	if (this.status === 200) { 

			        	if(mediaData.version && mediaData.version == 1){

			        		var data = xhr.responseText.split(','),
				        	playingNow = data[6];

			        	}else{

			        		var data = JSON.parse(xhr.responseText),
			        		playingNow = data.songtitle;	

			        	}

			        	radioData = data;

						var song = playingNow.split('-'),
		        		artist = $.trim(song[0]),
		                title = $.trim(song[1]);

						radioDataProcessed = {artist: artist, title:title, thumb: null};

						if(lastPlayedSong){
							if(lastPlayedSong != playingNow){//compare last song
								if(settings.getRadioArtwork)processArtwork(artist,title);
								else if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);
			            	}else{
			            		console.log('data hasnt changed')
								//data hasnt changed
							}
						}else{
							//first time
							if(settings.getRadioArtwork)processArtwork(artist,title);
							else if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);
						}
					}

					lastPlayedSong = playingNow;

				}else{  
		           
		            if(!radioDataInited){
		            	if(lastPlayedIntervalID)clearInterval(lastPlayedIntervalID);
				    	lastPlayedIntervalID = setInterval(function(){
				    		getShoutcastData();
					    },lastPlayedInterval);
				    }
		            
		        }  

			}

			if(mediaData.version && mediaData.version == 1){
	        	xhr.open("GET", cors[activeCors] + ip + "/7.html", true);
	        }else{
	        	var sid = settings.sid || '1';
	        	var url = cors[activeCors] + ip + "/stats?sid="+sid+"&json=1";
	        	xhr.open("GET", url, true);	
	        } 

	        xhr.send();

	        window.radioDataXHR = xhr;

		}

		function getIcecastData(){

			var ip = mediaData.path;
	    	if(ip.substring(ip.length-1) == ";"){
	    		ip = ip.substring(0, ip.length-1);
	    	}

			if(window.radioXHR)window.radioXHR.abort(); 

			var xhr = new XMLHttpRequest();
	        xhr.onerror = function (e) {
	            //console.error(xhr.statusText);
	        };
	        xhr.onreadystatechange = function () {

	            if (this.readyState === 4) {  
	            	//console.log(this.status)
	            	//console.log(this.responseText)

			        if (this.status === 200) {  

			        	var playingNow;

			        	if(this.responseText.indexOf('{"icestats":')>-1){

			                var response = JSON.parse(this.responseText);

			                if(response.icestats.source.length === undefined){
			                    var data = response.icestats.source;
			                }else{
			                    var i, len = response.icestats.source.length;
			                    for (i = 0; i < len; i++) {
			                        var str = response.icestats.source[i].listenurl;
			                        if (str.indexOf(mediaData.mountpoint) >= 0) {
			                            data = response.icestats.source[i];
			                            break;
			                        }
			                    }
			                }

			                radioData = data;

			                if(data.yp_currently_playing)playingNow = data.yp_currently_playing;
			                else{
			                	var artist = data.artist, title = data.title;
			                	if(artist && title)playingNow = artist + '-' + title;
			                	else if(title)playingNow = title;
			                }

						}
						else if(this.responseText.indexOf('class="streamdata"')>-1){

							if(this.responseText.indexOf('Mount Point /'+mediaData.mountpoint)>-1){
								var s1 = this.responseText.substr(this.responseText.indexOf('Mount Point /'+mediaData.mountpoint)),
								s2 = s1.substr(s1.indexOf('Current Song:')),
								s3 = s2.substr(s2.indexOf('<td class="streamdata">')+23),
								s4 = s3.substr(0, s3.indexOf('</td>'));	

								if(!HAPUtils.isEmpty(s4))playingNow = s4;
							}
						}
						else if(this.responseText.indexOf('class="streamstats"')>-1){

							if(this.responseText.indexOf('Mount Point /'+mediaData.mountpoint)>-1){
								var s1 = this.responseText.substr(this.responseText.indexOf('Mount Point /'+mediaData.mountpoint)),
								s2 = s1.substr(s1.indexOf('Currently playing:')),
								s3 = s2.substr(s2.indexOf('<td class="streamstats">')+24),
								s4 = s3.substr(0, s3.indexOf('</td>'));	

								if(!HAPUtils.isEmpty(s4))playingNow = s4;
							}
						}

						if(playingNow){

							var song = playingNow.split('-'),
			                artist = $.trim(song[0]),
			                title = $.trim(song[1]);

			                radioDataProcessed = {artist: artist, title:title, thumb: null};

			                if(lastPlayedSong){
								if(lastPlayedSong != playingNow){//compare last song
									if(settings.getRadioArtwork)processArtwork(artist,title);
									else if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);
				            	}else{
									//data hasnt changed
									//console.log('data hasnt changed')
								}
							}else{
								//first time
								if(settings.getRadioArtwork)processArtwork(artist,title);
								else if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);
							}

							lastPlayedSong = playingNow;

						}else{
							//console.log('playingNow empty!')
							radioDataProcessed = {artist: defaultSongArtist, title:defaultSongTitle, thumb: null};
							if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);

						}

	            	}else{  

		            	//console.log(this.statusText)
		            	if(this.status == 404 && this.statusText == 'Not Found'){
		            		//status-json.xsl does not exist, try status.xsl
		            		console.log(icecastStatusArr[activeIcecastStatus] + ' does not exist!')

		            		activeIcecastStatus++;
		            		if(icecastStatusArr[activeIcecastStatus]){
		            			if(!radioDataInited){
					            	if(lastPlayedIntervalID)clearInterval(lastPlayedIntervalID);
									getIcecastData();
					            }
		            		}else{
	            				//display default data
		            			radioDataProcessed = {artist: defaultSongArtist, title:defaultSongTitle, thumb: null};
								if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);
		            		}

		            	}else{

		            		if(!radioDataInited){
				            	if(lastPlayedIntervalID)clearInterval(lastPlayedIntervalID);
						    	lastPlayedIntervalID = setInterval(function(){
									getIcecastData();
							    },lastPlayedInterval);
				            }
		            	}
			        } 
			    }
	        };

	        xhr.open('GET', cors[activeCors] + ip + icecastStatusArr[activeIcecastStatus], true);
	        xhr.send();

	        window.radioXHR = xhr;

		}

		function getRadiojarData(){

	    	if(window.radioDataXHR)window.radioDataXHR.abort(); 

	        var xhr = new XMLHttpRequest;
	        xhr.onerror = function (e) {
	            //console.error(xhr.statusText);
	        };
	        xhr.onreadystatechange = function () {

	            if (this.readyState === 4){
	            	if (this.status === 200) { 
						//console.log(xhr.responseText)

			        	var data = JSON.parse(xhr.responseText),
			        	artist = data.artist,
			            title = data.title,
			            playingNow = artist + ' - ' +  title,
			            thumb = data.thumb || null; 

			        	radioData = data;

			        	radioDataProcessed = {artist: artist, title:title, thumb: thumb};

			        	if(lastPlayedSong){
							if(lastPlayedSong != playingNow){//compare last song
								if(settings.getRadioArtwork && thumb == null)processArtwork(artist,title);
								else if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);
			            	}else{
			            		//console.log('data hasnt changed')
								//data hasnt changed
							}
						}else{
							//first time
							if(settings.getRadioArtwork && thumb == null)processArtwork(artist,title);
							else if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);
						}
						
						lastPlayedSong = playingNow;

					}else{  
			            if(!radioDataInited){
			            	if(lastPlayedIntervalID)clearInterval(lastPlayedIntervalID);
					    	lastPlayedIntervalID = setInterval(function(){
					    		getRadiojarData();
						    },lastPlayedInterval);
			            }
			        }  
			    }

	        };

		    var w = "http://www.radiojar.com/api/stations/" + mediaData.mountpoint + "/now_playing/";
	        xhr.open("GET", cors[activeCors] + w, true);
	        xhr.send();

	        window.radioDataXHR = xhr;

		}

		function processArtwork(artist,title){
			if(radioCanceled)return;

			artist = formatArtist(artist);
	        title = formatTitle(title);

            var i = cors[activeCors] + "https://itunes.apple.com/search?type=jsonp&term==" + encodeURI(artist) + "-" + encodeURI(title) + "&media=music&limit=1";

            var xhr = new XMLHttpRequest();
            xhr.onerror = function (e) {
	            //console.error(xhr.statusText);
	        };
	        xhr.onreadystatechange = function () {

			    if (this.readyState === 4) {  
			        if (this.status === 200) {  

		               	var data = JSON.parse(this.responseText);
		                if(data.resultCount){

		                	//calculate thumb size
							var w = playerThumb.width(),
							s = HAPUtils.closestNumber(settings.artworkSize, w),
							size = s+'x'+s

							var thumb = data.results[0].artworkUrl100.replace('100x100', size)

		                }else{
		                	var thumb = mediaData.thumbDefault;
		                } 
		                radioDataProcessed.thumb = thumb;

		                if(!radioCanceled)$(self).trigger('HAPRadioData.DATA_READY', radioDataProcessed);

		                if(lastPlayedIntervalID)clearInterval(lastPlayedIntervalID);
				    	lastPlayedIntervalID = setInterval(function(){
				    		self.getData();
					    },lastPlayedInterval);

					    radioDataInited = true;

		            }else{  
		            	if (this.status === 403) {  
		            		
	            			activeCors++;
	            			if(activeCors > cors.length-1)activeCors = 0;
				        	processArtwork(artist,title);
					    	
						}
			        } 
			    }
	        }
	        xhr.open('GET',i, true);
	        xhr.send();

	        window.artworkDataXHR = xhr;

		}

		this.destroy = function(){

			radioCanceled = true;

			if(lastPlayedIntervalID)clearInterval(lastPlayedIntervalID);
			lastPlayedIntervalID = null;

			if(window.radioDataXHR){
				window.radioDataXHR.abort(); 
				delete window.radioDataXHR;
			}

			if(window.artworkDataXHR){
				window.artworkDataXHR.abort(); 
				delete window.artworkDataXHR;
			}

			activeCors = 0;
			radioDataInited = false;
			lastPlayedSong = null;

		}

		this.getRadioData = function(){//get whole radio data

			return radioData;

		}

		function formatArtist(artist){

	        artist = artist.toLowerCase();			
			artist = $.trim(artist);
	        if (artist.includes("&")) {
	             artist = artist.substr(0, artist.indexOf(' &'));				
	        }
	        else if(artist.includes("feat")) {
	            artist = artist.substr(0, artist.indexOf(' feat'));
	        } else if (artist.includes("ft.")) {
	            artist = artist.substr(0, artist.indexOf(' ft.'));
	        }

	        return artist;
	    }
		
		function formatTitle(title){

	        title = title.toLowerCase();            
			title = $.trim(title);
	        if (title.includes("&")) {
	            title = title.replace('&', 'and');				
	        }
	        else if(title.includes("(")) {
	            title = title.substr(0, title.indexOf(' ('));
	        } else if (title.includes("ft")) {
	            title = title.substr(0, title.indexOf(' ft'));
	        }

	        return title;
	    }

	};	

	window.HAPRadioData = HAPRadioData;

}(window,jQuery));
