(function (window, $){
	"use strict"	
	var HAPShareManager = function(settings){

		var facebookAppId = settings.facebookAppId,
		isMobile = HAPUtils.isMobile()
			
		if(!HAPUtils.isEmpty(facebookAppId) && window.location.protocol != 'file:'){
			injectFbSdk(facebookAppId);
		}

		this.share = function(type, data){
				
			var prefix = ('https:' == window.location.protocol ? 'https:' : 'http:'),
			w = 600, h = 300, cw = (window.screen.width - w) / 2, ch = (window.screen.height - h) / 2,

			title = data.title || '',
			description = data.description || '',
			thumb = data.thumb || '',
			url = data.share || window.location.href, 
			path;

			if(!HAPUtils.relativePath(thumb))thumb = HAPUtils.qualifyURL(thumb);

			if(type == "facebook"){	

				if(HAPUtils.isEmpty(facebookAppId)){
					alert('facebookAppId has not been set in settings!');
					return;
				}

				if(window.FB){

	                FB.ui({
	                    method: 'share_open_graph',
	                    action_type: 'og.shares',
	                    action_properties: JSON.stringify({
	                        object: {
	                            'og:url': url,
	                            'og:title': title,
	                            'og:description': description,
	                            'og:image': thumb
	                        }
	                    })
	                });
				}

			}else if(type == "twitter"){	

				path = prefix+'//twitter.com/share?url='+encodeURIComponent(url)+'&text='+encodeURIComponent(title);

			}else if(type == "tumblr"){	

				path = prefix+'//www.tumblr.com/share/link?url='+encodeURIComponent(url)+'&amp;name='+encodeURIComponent(title)+'&amp;description='+encodeURIComponent(description);

			}else if(type == "whatsapp"){	

				if(isMobile){

		            var message = encodeURIComponent(title)+" - "+encodeURIComponent(url),
		            whatsapp_url = "whatsapp://send?text="+message;
		            window.location.href = whatsapp_url;
					return;

				}else{
					alert(settings.whatsAppWarning);
				}

			}

			if(path)window.open(path, '', 'menubar=no,toolbar=no,resizable=yes,scrollbars=yes,width='+w+',height='+h+',left='+cw+',top='+ch+'');
		}	

		function injectFbSdk(fs_api_id) {
			
			// this loads the Facebook API
		    (function (d, s, id) {
		        var js, fjs = d.getElementsByTagName(s)[0];
		        if (d.getElementById(id)) { return; }
		        js = d.createElement(s); js.id = id;
		        js.src = "//connect.facebook.net/en_US/sdk.js";
		        fjs.parentNode.insertBefore(js, fjs);
		    }(document, 'script', 'facebook-jssdk'));

		    window.fbAsyncInit = function () {
		        FB.init({
		            appId: fs_api_id,
		            xfbml: true,
		            version: 'v2.9'
		        });
		    };

		}

	};	

	window.HAPShareManager = HAPShareManager;

}(window,jQuery));
